unit u1Easy;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses zlib;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  Stream1 : TMemoryStream;
  Stream2 : TMemoryStream;
  Stream3 : TMemoryStream;
  UnComprSize : Longint;
  BufferSize : Longint;
begin
  Stream1 := TMemoryStream.Create;
  Stream2 := TMemoryStream.Create;
  Stream3 := TMemoryStream.create;
  try
    Stream1.LoadFromFile('c:\windows\win.ini');
    UnComprSize := Stream1.Size;

    { buffer for compressed data must be Uncompr size + 0.1% + 12 bytes }
    BufferSize := UnComprSize + (UnComprSize div 1024) + 12;
    Stream2.SetSize(BufferSize);

    compress(Stream2.Memory, BufferSize, Stream1.Memory, UnComprSize);
    { BufferSize now holds actual compressed data size. }

    Stream3.SetSize(UnComprSize);
    uncompress(Stream3.Memory, UnComprSize, Stream2.Memory, BufferSize);

    Label1.Caption := Format('Uncompressed size is %d', [UnComprSize]);
    Label2.Caption := Format('Compressed size is %d', [BufferSize]);

    Memo1.Lines.LoadFromStream(Stream3);
  finally
    Stream1.Free;
    Stream2.Free;
    Stream3.Free;
  end;
end;

end.
